
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《Java编码指南：编写安全可靠程序的75条建议》—— 指南10：不要使用clone()方法来复制不可信的方法参数 / iVAN</title>

    <meta name="description" content="《Java编码指南：编写安全可靠程序的75条建议》—— 指南10：不要使用clone()方法来复制不可信的方法参数 指南10:不要使用clone()方法来复制不可信的方法参数 创建可变方法参数的防御性副本,可以减轻来自各种安全漏洞的威胁,更多信息请参考&lt;The CERT Oracle Secure Coding Standard for Java&gt;[Long 2012]的&quot;OBJ06-J. Defensively copy mutable inputs and mutable internal components&quot;.然而,对clone()方法不当地使用,可以使攻击者利用这一漏 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《Java编码指南：编写安全可靠程序的75条建议》—— 指南10：不要使用clone()方法来复制不可信的方法参数</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>指南10：不要使用clone()方法来复制不可信的方法参数</h3>
<p>创建可变方法参数的防御性副本，可以减轻来自各种安全漏洞的威胁，更多信息请参考《The CERT Oracle Secure Coding Standard for Java》[Long 2012]的“OBJ06-J. Defensively copy mutable inputs and mutable internal components”。然而，对clone()方法不当地使用，可以使攻击者利用这一漏洞，提供看上去正常的参数，但随后返回意想不到的结果。这样的对象可能因此绕过验证和安全检查。当这样一个类可能会作为一个参数传递给一个方法时，应当把这个参数视为不可信任的，同时不要使用该类提供的clone()方法。另外，不要使用未经final修饰的类的clone()方法来创建防御性副本。</p>
<p>该指南是指南15的一个特定实例。</p>
<h4>违规代码示例</h4>
<p>下面的违规代码示例定义了一个validateValue()方法来验证时间值。</p>
<pre><code>private Boolean validateValue(long time) {
　// Perform validation
　return true; // If the time is valid
}
private void storeDateInDB(java.util.Date date)
　 throws SQLException {
　final java.util.Date copy = (java.util.Date)date.clone();
　if (validateValue(copy.getTime())) {
　　Connection con =
　　　DriverManager.getConnection(
　　　　"jdbc:microsoft:sqlserver://&lt;HOST&gt;:1433",
　　　　"&lt;UID&gt;", "&lt;PWD&gt;"
　　　);
　　PreparedStatement pstmt =
　　　 con.prepareStatement("UPDATE ACCESSDB SET TIME = ?");
　　pstmt.setLong(1, copy.getTime());
　　// ...
　}
}```
storeDateInDB()方法接受一个不可信的日期参数，尝试利用其clone()方法创建一个防御性副本。这就允许攻击者通过一个继承自Date的恶意日期类来取得程序的控制权。如果攻击者的代码运行特权和storeDateInDB()方法一样，那么他只需在clone()方法里嵌入恶意代码：
</code></pre>
<p>class MaliciousDate extends java.util.Date {<br />
　@Override<br />
　public MaliciousDate clone() {<br />
　　// malicious code goes here<br />
　}<br />
}```<br />
然而，如果攻击者只能提供恶意的日期参数，但是没有足够特权，他还是可以绕过验证，从而混淆程序的其余部分。试想一下这个例子：</p>
<pre><code>public class MaliciousDate extends java.util.Date {
　private static int count = 0;

　@Override
　public long getTime() {
　　java.util.Date d = new java.util.Date();
　　return (count++ == 1) ? d.getTime() : d.getTime() - 1000;
　}
}```
getTime()方法第一次被调用时，这个恶意的日期看上去是一个正常的日期对象，这使得它绕过了storeDateInDB()里的验证方法。然而，实际存储在数据库中的时间却是不正确的。

####合规解决方案
下面的合规解决方案避免了clone()方法的使用。取而代之，创建了一个新的java.util.Date对象，并在后续的代码中，使用该对象做访问控制检查和数据库插入。
</code></pre>
<p>private void storeDateInDB(java.util.Date date)<br />
　 throws SQLException {<br />
　final java.util.Date copy = new java.util.Date(date.getTime());<br />
　if (validateValue(copy.getTime())) {<br />
　　Connection con =<br />
　　　DriverManager.getConnection(<br />
　　　　"jdbc:microsoft:sqlserver://:1433",<br />
　　　　"", ""<br />
　　　);<br />
　　PreparedStatement pstmt =<br />
　　　con.prepareStatement("UPDATE ACCESSDB SET TIME = ?");<br />
　　pstmt.setLong(1, copy.getTime());<br />
　　// ...<br />
　}<br />
}```</p>
<h4>违规代码示例（CVE-2012-0507）</h4>
<p>下面的违规代码示例展示了一个Java核心类AtomicReferenceArray的构造函数，它来自于Java 1.7.0版本的第2次更新。</p>
<pre><code>public AtomicReferenceArray(E[] array) {
　// Visibility guaranteed by final field guarantees
　this.array = array.clone();
}```
这段代码的调用导致漏洞被利用，在2012年4月影响了600 000台Macintosh电脑。1

####合规解决方案（CVE-2012-0507）
在Java 1.7.0版本的第3次更新中，对上面提到的构造函数进行了修改，使用Arrays.copyOf()方法替换了clone()方法。
</code></pre>
<p>public AtomicReferenceArray(E[] array) {<br />
　// Visibility guaranteed by final field guarantees<br />
　this.array = Arrays.copyOf(<br />
　　array, array.length, Object[].class);<br />
}```</p>
<h4>适用性</h4>
<p>使用clone()方法复制不可信的参数会给攻击者执行任意代码的机会。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 21:46:00</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e8%a7%a3%e5%86%b3%e6%96%b9%e6%a1%88/" title="解决方案">解决方案</a>, <a href="https://www.iamivan.net/tag/%e5%ae%89%e5%85%a8/" title="安全">安全</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《Java编码指南：编写安全可靠程序的75条建议》—— 指南10：不要使用clone()方法来复制不可信的方法参数的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkwnvb.html" rel="bookmark">《Java编码指南：编写安全可靠程序的75条建议（英文版）》&mdash;&mdash; 第2章 编写第一个程序 2&period;1 编写程序所需的工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 编写第一个程序 本章介绍如下内容: 在文本编辑器中输入一个Java程序: 使用括号组织程序: 将信息存储到变量中: 显示存储在变量中的信息: 保存.编译和运行程序. 第1章已经提到,计算机程序是一组告诉计算机做什么的指令.这些指令使用编程语言输入到计算机中. 在本章,读者将通过将指令输入到文本编辑器的方式来创建第一个Java程序.输入完毕之后,可以保存.编译并测试该程序.然后你可以破坏该程序,然后再进行修复. 2.1 编写程序所需的工具 第1章讲到,要创建Java程序,你必须有支持Jav			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDd4ez.html" rel="bookmark">《Effective Ruby：改善Ruby程序的48条建议》一第9条：提防Ruby最棘手的解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第9条:提防Ruby最棘手的解析 说到命名规则,Ruby给了我们很大的自由.肃然不像Lisp那样的语言一样自由,但Ruby允许我们在方法末尾使用三个字母数字以外的符号:&quot;?&quot;.&quot;!&quot;和&quot;=&quot;.三个字符中的两个具有纯粹的美感,而另一个在Ruby中有特殊的含义. 如你所知,以问号结束的方法名既不会改变任何事情,也不会使Ruby对它特殊对待.这仅仅是一个为Ruby程序员所接受的命名惯例,以此来说明方法将返回一个布尔值.(要知道什么是Ruby中的布尔值,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8YqGZz.html" rel="bookmark">《Effective Ruby：改善Ruby程序的48条建议》一第8条：初始化子类时调用super</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第8条:初始化子类时调用super Ruby中,类没有传统的OOP式的构造方法.如果想要控制对象的初始状态,我们得写一个名为initialize的方法并在那里做必要的工作.在一个新对象被分配空间之后,就会在new中调用这个方法.如果你不在自己的类中自定义initialize方法,你的类将从BasicObject类中继承默认实现.不过这并不那么有效.事实上,那是个空方法,什么也没做.它只是在那里,使得new方法在你没有自定义initialize方法时有处可调.还好,很多时候BasicObject#			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWyPOz.html" rel="bookmark">《Effective Ruby：改善Ruby程序的48条建议》一第15条：优先使用实例变量而非类变量</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第15条:优先使用实例变量而非类变量 Ruby语言存在两种用@标识的变量:实例变量和类变量.每个运行中的Ruby程序都有自己的私有实例变量集,如你所知,它们的名字都以&quot;@&quot;符号开头.修改对象的实例变量不会影响另一个对象的同名实例变量.(但是改变变量就是另外一回事儿了:如果两个对象共享第三个对象的引用,那么修改自然会影响到另一个了.详见第16条). 类变量(那些以&quot;@@&quot;开头的变量)则被区别对待.不同于绑定在单个上对象,类变量被绑定到一个类型之上,并且它们对于那个类的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwy3eWM.html" rel="bookmark">《Effective Ruby：改善Ruby程序的48条建议》一第13条：通过&amp;quot&semi;&amp;lt&semi;&equals;&amp;gt&semi;&amp;quot&semi;操作符实现比较和比较模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第13条:通过&quot;&lt;=&gt;&quot;操作符实现比较和比较模块 在第12条中提到了四种测试对象相等性的方法.如果你对对象的排序和比较有兴趣,那么你就需要进一步定义其他的比较操作符了.与等价操作符不同的是,类并没有从其他比较操作符中继承默认实现.还好,Ruby提供了一种简便的方式来实现它,这一点我们会在稍后讨论.首先,让我们做一件有意思的事情,就是实现一个具有特殊序列的类.作为程序员,我们已经习惯了奇怪的版本号的定义,因此它们并不会给我们造成太多的困扰.但对外行来说就完全不同了.如何比较&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7wD2Xz.html" rel="bookmark">《Effective Ruby：改善Ruby程序的48条建议》一第2章 类、对象和模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 类.对象和模块面向对象程序设计(OOP)是Ruby的谋生之道.Ruby通常被认为是一门纯粹的面向对象语言,因为Ruby中的任何事物都是或者可以被转化为一个对象,我是说每个事物.Ruby的对象模型受到Smalltalk的严重影响,因此,如果你是由C++或Java转型而来的程序员,可能会觉得这和你曾使用过的其他语言有些不同.类也是对象这个事实足以让你的思维陷入无限递归模式.此外还有一些陷阱,如子类不会自动初始化其超类,以及定义变量和调用setter方法存在模糊的概念.本章将针对这些问题进行整			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxPlDGM.html" rel="bookmark">如何有效编写软件的75条建议</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.你们的项目组使用源代码管理工具了么? 应该用.VSS.CVS.PVCS.ClearCase.CCC/Harvest.FireFly都可以.我的选择是VSS. 2.你们的项目组使用缺陷管理系统了么? 应该用.ClearQuest太复杂,我的推荐是BugZilla. 3.你们的测试组还在用Word写测试用例么? 不要用Word写测试用例(Test Case).应该用一个专门的系统,可以是Test Manager,也可以是自己开发一个ASP.NET的小网站.主要目的是Track和Browse. 4			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJANLqp.html" rel="bookmark">《Effective Ruby：改善Ruby程序的48条建议》一第6条：了解Ruby如何构建继承体系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第6条:了解Ruby如何构建继承体系 问题:当你向一个对象发送消息时,你知道Ruby是怎么定位到那个正确的方法的吗?答案看上去很简单:使用继承体系.之所以说答案是看上去简单,因为Ruby构建继承体系是在幕后进行的.这是Ruby用自己的方式来隐藏真正发生的事情的罕见情形之一,它常常带来不必要的困惑.Ruby提供给我们的用来发现继承关系中的类的方法并能完全解释其本质.还好,Ruby解释器在内部构建的继承体系是一致而简单的,只要你明白一些它的技巧. 探索Ruby查询方法的机制将揭开语言实现方式的面纱,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZBmloz.html" rel="bookmark">《Effective Ruby：改善Ruby程序的48条建议》一第11条：通过在模块中嵌入代码来创建命名空间</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第11条:通过在模块中嵌入代码来创建命名空间 假设你正在做一个订购个性化笔记本(那种过时的纸质笔记本)的应用程序.客户能够在众多装订方式中选择,如使用金属钉针装订或使用传统的胶水装订.你决定创建一个类来表示装订类型,并将其他参数一同放在里面.然而很遗憾,事情并非计划的那样.下面的类定义有什么问题呢? 乍一看,似乎什么都是对的.这是没有语法错误的,但如果你在IRB中运行这个类,你会看到还真有点问题.当你执行这段代码来创建新的对象时,你会发现事实和预期不同.然而如果这段代码不是在定义一个类那它又做了			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMr34Op.html" rel="bookmark" class="title">tipask问答系统模板文件对照</a>
					<div>
						tipask问答系统模板文件对照 模板目录:tipask\view\default ask.html :提问页面 category.html:分类浏览页面 footer.html :页面底部 getp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9JGXp.html" rel="bookmark" class="title">J2ME编程最佳实践之灵活的RMS应用</a>
					<div>
						编程 MIDP应用程序的标准持久化方案就是使用RMS.RMS类似于一个小型数据库,RecordStore相当于数据库的表,每个&quot;表&quot;由若干记录(Record)构成,一条记录就是一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOgvkz.html" rel="bookmark" class="title">分离美工 杜绝重复</a>
					<div>
						重复 如果你正在设计一个交互式网站,你一定会关注两个主要的问题,就是美工和程序.这也是一个网站在建设中抛开其内容之后最关键的要素.通常有两种方式来协调美工和程序之间的关系: 1.先做好美工页面,然后由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMN6JyM.html" rel="bookmark" class="title">ASP&period;NET&plus;Atlas创建客户端Web应用程序</a>
					<div>
						asp.net|web|程序|创建|客户端 提要 本文介绍了Atlas框架,并探讨它的客户端和服务器端类库及其编程模型.另外,本文还详细剖析了一个支持Atlas功能的示例Web应用程序. 一. 开发环 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv2eAM.html" rel="bookmark" class="title">张东：实战解析SEO软文引子的写法</a>
					<div>
						在写SEO软文的过程中,许多朋友都不知道该如何着手,根据百度分词的原理,SEO软文模型可以用比较通俗的说法就是&quot;龙头凤尾猪肚子&quot;,文章引子就是龙头,文章结尾就是凤尾,文章内容就是猪 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrP11z.html" rel="bookmark" class="title">企业营销塑价值：企业如何做好线的上品牌营销</a>
					<div>
						网络营销与传统的营销模式相比,更具有&quot;速度快.投资成本小.速度快.低风险&quot;等特点,运用得当更可得到巨大的商业回报.因此网络营销作为一种全新的营销模式,很快的被企业所接受,甚至于不惜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AZ3Ap.html" rel="bookmark" class="title">自己也能做软驱 让Subst&period;exe苏醒</a>
					<div>
						曾几何时,受到每个电脑爱好者重用的软驱成了明日黄花,因此不少品牌机厂家在新推出的型号中已开始尝试取消软驱,而以USB接口的闪存来取代它,笔记本电脑尤甚. 不过,缺少了软驱这位老朋友,有时还真不太方便. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NL9kz.html" rel="bookmark" class="title">电商网站商品页设计超全面指南</a>
					<div>
						  商品详情页是电子商务网站中最容易与用户产生交集共鸣的页面,详情页的设计极有可能会对用户的购买行为产生直接的影响.因此,商品详情页面的设计会涉及到运营层面,在美观实用的基础上,将要表达的信息尽可能用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNWDwM.html" rel="bookmark" class="title">在移动界面设计中应用费茨法则</a>
					<div>
						  在人机交互理论中,费茨法则是非常基本的准则.无论是桌面界面设计还是笔记本的界面设计,都要遵循这一定则,对于日益复杂的移动设备来说,这一法则是否依然适用?我们一起来探索一下. 首先,来了解一下什么是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWQWop.html" rel="bookmark" class="title">五法宝抢救损坏的word文档</a>
					<div>
						 文档-word文档损坏怎么修复&quot;&gt; 遇到以上已损坏的文档,其实,您不用着急,由于咱们还是有一些办法能够修正损坏文档,恢复受损文档中的文字. 下面是详细的操作过程. 1 采用专用修复功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwDKYb.html" rel="bookmark" class="title">桌面图标打不开怎么办</a>
					<div>
						我们在使用电脑时,会发现有时双击桌面上的图标打不开的情况,这是什么原因呢?难道电脑中毒了?下面我们就一起来找一下原因及解决方法. 方法1 双击打开桌面上&quot;我的电脑&quot;图标,单击菜单栏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1kv4b.html" rel="bookmark" class="title">Win7上如何更好的搜索文件？</a>
					<div>
						  1. 单击&quot;开始&quot;按钮,然后单击&quot;文档&quot;.&quot;音乐&quot; 或&quot;图片&quot;. 2. 在库窗格(位于文件列表上方)中,单击&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3gDBM.html" rel="bookmark" class="title">新浪微博什么是分享体验环节？</a>
					<div>
						  用户在使用了您的优惠券消费后,可以回到活动页面分享使用或消费体验,为了让用户有充足的时间分享体验,建议您的活动开始和结束时间间隔大于20天.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq89lRb.html" rel="bookmark" class="title">图说全球浏览器市场份额变迁史</a>
					<div>
						今天发现了一个不错的图表,全球浏览器市场份额变迁史:1994-2012,浏览器的兴衰背后是整个科技行业的变迁. [编辑推荐]					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8lWZb.html" rel="bookmark" class="title">源码BaseAdapter浅谈</a>
					<div>
						BaseAdapter是一个抽象类,他 实现了listAdapter 跟spinnerAdapter俩个接口 listAdapter是继承了Adapter这个接口 在adapter里边有   void ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJk3qwb.html" rel="bookmark" class="title">iOS开发之文件（分段）下载</a>
					<div>
						1.HTTP HEAD方法 ? 1 2 3 4 5 6 7 NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWmP6p.html" rel="bookmark" class="title">光标的一些操作总结&lowbar;javascript技巧</a>
					<div>
						IE下的Range操作比Mozilla下强很多,这里只讨论IE下的操作. 这里选介绍几个光标定位的特点: 1.光标不变     直接obj.focus(),光标会返回之前的位置,即位置不变 2.光标在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkgOvb.html" rel="bookmark" class="title">elasticsearch命令</a>
					<div>
						1.如何关闭ES,elasticsearch关闭办法 1.使用head插件 找到想关掉的节点进行关停 2.使用命令kill杀掉服务器的ES进程即可 1.查找ES进程 ps -ef | grep ela ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE47BZz.html" rel="bookmark" class="title">移动开发-android studio用不了popwin的showAtLocation</a>
					<div>
						问题描述 android studio用不了popwin的showAtLocation 用不showAtLocation,但是showAsDropDown又没有问题.第二个参数,关于gravity的一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmwEqM.html" rel="bookmark" class="title">java 串口通信</a>
					<div>
						/** *//****************************************** * 程序文件名称:SendComm.java * 功能:从串行口COM1中发送数据 ******** ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rPXKp.html" rel="bookmark" class="title">orcle-微软工作流支持ORCLE数据库吗</a>
					<div>
						问题描述 微软工作流支持ORCLE数据库吗 微软工作流支持ORCLE数据库吗 ?有参考资料没有?或者实现思路 解决方案 wf只是一个基础框架,它本身需要靠你编写activty去实现具体的逻辑,所以任何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKdo8b.html" rel="bookmark" class="title">拆开阿里小蜜的内核，看智能人机交互的实现逻辑</a>
					<div>
						在全球人工智能领域不断发展的今天,包括Google.Facebook.Microsoft.Amazon.Apple等互联公司相继推出了自己的智能私人助理和机器人平台. 智能人机交互通过拟人化的交互体验 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJlPRp.html" rel="bookmark" class="title">MyBatis学习总结&lpar;五&rpar;&mdash;&mdash;实现关联表查询</a>
					<div>
						一.一对一关联 1.1.提出需求 根据班级id查询班级信息(带老师的信息) 1.2.创建表和数据 创建一张教师表和班级表,这里我们假设一个老师只负责教一个班,那么老师和班级之间的关系就是一种一对一的关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12D9xp.html" rel="bookmark" class="title">iOS Foundation 框架 224 篇相关文档分类整理</a>
					<div>
						iOS Foundation 框架 224 篇相关文档分类整理 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非商业用途-保持一致&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xGLab.html" rel="bookmark" class="title">奇怪、为什么会有这样的错误，c&num;窗体程序在有的计算机上运行报错。</a>
					<div>
						问题描述 有没有人遇到过这样的问题,编写的C#程序运行在某台计算机上出现这样的问题.其他的计算机都能运行无错..错误信息如下 解决方案 解决方案二:还没有遇到过帮定一下解决方案三:谢谢lsj_zrp, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xoVRb.html" rel="bookmark" class="title">苹果超2亿美元收购社交媒体分析公司Topsy</a>
					<div>
						消息人士周一透露,苹果已经以超过2亿美元的价格收购了社交http://www.aliyun.com/zixun/aggregation/7907.html&quot;&gt;媒体分析公司Topsy L ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnDXJM.html" rel="bookmark" class="title">自动化测试用例设计</a>
					<div>
						序言:自动化测试中,自动化测试用例是一个重点中的重点,个人以为,到底如何去定位自动化测试用例设计的 形式和发展是决定自动化测试成败的关键,根据一些研究和看法,我写了一个自动化测试用例设计的一个大概情况 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4eZ7Yb.html" rel="bookmark" class="title">javaweb-struts2问题求解释求解释</a>
					<div>
						问题描述 struts2问题求解释求解释 struts2有一个内置校验器功能,就是用Xxx-validation.xml来校验,我想问的是这个文件是通过建立xml文件,然后取名为Xxx-validat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqW8D3z.html" rel="bookmark" class="title">HIV检测器，售价只有34美元，配合智能手机即可在家检测</a>
					<div>
						摘要: 截至2013年底,全球现存活艾滋病病毒感染者/艾滋病人超过3500万人,平均每天新增感染人数达6000人.截至2014年10月,中国现存活艾滋病病毒感染者/艾滋病人达49.7万人,其中死亡15 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKQOvM.html" rel="bookmark" class="title">固定表格行列&lpar;expression&rpar;在IE下适用&lowbar;javascript技巧</a>
					<div>
						这是一种在IE下适用的固定行列的方法.其具体代码如下: 复制代码 代码如下: &lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.0 Transitio ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
